/*******************************************************************************
 * FoxPhysicalMaterialProperty generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxPhysicalMaterialProperty extends PhysicalMaterialPropertyBase
    editinlinenew
    collapsecategories
    hidecategories(Object,Object);

struct DamageModifier
{
    var() class<FoxDamageType> DamageClass;
    var() float Multiplier;

    structdefaultproperties
    {
        DamageClass=none
        Multiplier=0.0
    }
};

var(ImpactEffects) editinline FoxPMPInfo_ImpactFX ImpactFX_Info;
var(FootSteps) editinline FoxPMPInfo_FootSteps FeetFX_Info;
var(Decals) editinline FoxPMPInfo_Decals StandardRoundDecal;
var(Decals) editinline FoxPMPInfo_Decals IncendiaryDecal;
var(Decals) editinline FoxPMPInfo_Decals HighVelocityDecal;
var(Decals) editinline FoxPMPInfo_Decals SlashingMeleeDecal;
var(Decals) editinline FoxPMPInfo_Decals BluntMeleeDecal;
var(Decals) editinline FoxPMPInfo_Decals MinigunDecal;
var() array<DamageModifier> DamageModifiers;

function int ModifyDamageBasedOnMaterial(int DamageAmount, class<DamageType> DamageType)
{
    local int DamageModifierIndex;

    DamageModifierIndex = 0;
    J0x0B:
    // End:0x9B [Loop If]
    if(DamageModifierIndex < DamageModifiers.Length)
    {
        // End:0x8D
        if(DamageModifiers[DamageModifierIndex].DamageClass == DamageType)
        {
            return int(DamageModifiers[DamageModifierIndex].Multiplier * float(DamageAmount));
        }
        ++ DamageModifierIndex;
        // [Loop Continue]
        goto J0x0B;
    }
    return DamageAmount;
    //return ReturnValue;    
}

static final simulated function PhysicalMaterial GetImpactPhysicalMaterial(const out ImpactInfo Impact)
{
    local PhysicalMaterial PhysMaterial;

    // End:0x7C
    if(FoxPawn(Impact.HitActor) != none)
    {
        PhysMaterial = FoxPawn(Impact.HitActor).GetPawnPhysMatFor(Impact);
    }
    // End:0x1EC
    else
    {
        // End:0xF8
        if(FoxHoloMan_Base(Impact.HitActor) != none)
        {
            PhysMaterial = FoxHoloMan_Base(Impact.HitActor).GetPawnPhysMatFor(Impact);
        }
        // End:0x1EC
        else
        {
            // End:0x169
            if(Impact.HitInfo.PhysMaterial != none)
            {
                PhysMaterial = Impact.HitInfo.PhysMaterial;
            }
            // End:0x1EC
            else
            {
                // End:0x1EC
                if(Impact.HitInfo.Material != none)
                {
                    PhysMaterial = Impact.HitInfo.Material.PhysMaterial;
                }
            }
        }
    }
    return PhysMaterial;
    //return ReturnValue;    
}
